#####################################################################################
#
#		:::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#####################################################################################
#
# slogan 1.3
#
# :
#	        .
#
# :  mrBuG <mrbug@eggdrop.org.ru>
# : Kreon <starcom2k@gmail.com> 
#
#  : irc.eggdrop.org.ru @ #eggdrop
# 
#####################################################################################
#
#        
#
# :
# 1.  (slogan.tcl)   scripts.
# 2.   eggdrop.conf:
# source scripts/slogan.tcl
#
# :
#    : 
# !slogan(!) [  ] -       
# !slogmode <notice|channel|none> -   [notice | |    ]
#    :
# !slogan(!) [  ] -       
#
#####################################################################################
# Last version of egglib_pub can be grabbed here:
# http://eggdrop.org.ru/scripts/egglib.zip

if { ![info exists egglib(ver)] } {
	putlog "***********************************************"
	putlog "             egglib_pub NOT FOUND !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "***********************************************"
	die
}

if { [expr {$egglib(ver) < 1.52}] } {
	putlog "***********************************************"
	putlog "    YOUR VERSION OF egglib_pub IS TOO OLD !"
	putlog "   Download last version of egglib_pub here:"
	putlog "  http://eggdrop.org.ru/scripts/egglib_pub.zip"
	putlog "***********************************************"
	putlog " version installed : $egglib(ver)"
	putlog " version required: 1.5.2"
	die
}

setudef str slogan-mode

bind pub - !slogan ::slogan::pub_slogan
bind msg - !slogan ::slogan::msg_slogan

bind pub - ! ::slogan::pub_slogan
bind msg - ! ::slogan::msg_slogan

bind pub m|m !slogmode ::slogan::pub_mode

namespace eval slogan {}

foreach p [array names slogan *] { catch {unset slogan($p) } }

set slogan(timeout) 	20

set slogan(use_proxy) 0
set slogan(proxy_host) "login:passwd@myproxy.host.ru"
set slogan(proxy_port) 3128

set slogan(ver) 		"1.3"
set slogan(authors) 	"mrBuG <mrbug@eggdrop.org.ru>, Kreon <starcom2k@gmail.com>"

proc ::slogan::msg_slogan { nick uhost hand args } {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	::slogan::slogan $nick $uhost $hand $nick $args
}

proc ::slogan::pub_slogan { nick uhost hand chan args } {
	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	if { ![::slogan::active $chan] } return
	::slogan::slogan $nick $uhost $hand $chan $args
}

proc ::slogan::slogan { nick uhost hand chan args } {
	global slogan; global sp_version 

	if { [llength [split [lindex $args 0] ] ] > 1 || [llength [split [lindex $args 0] ] ] == 0 } { set args [split [lindex $args 0]] }
	if {[llength $args]==0} { ::egglib::outh $nick $chan "!" "< ?>"; return }

	::egglib::log $chan $nick "slogan" "q='$args'"

	if {[info exists sp_version]} {set params $args} else {

	set params $args

	set params [encoding convertfrom iso8859-1 $params]

	regsub -all -nocase -- "" $params {%B8} params

	}

	regsub -all -- {\ } $params {%20} params;
	regsub -all -- {\#} $params {%23} params
	regsub -all -nocase -- "{" $params  "" params
	regsub -all -nocase -- "}" $params "" params


	if {[info exists slogan(host,$uhost)]} { ::egglib::outn $nick "    ..."; return }

	set slogan(host,$uhost) 1

	set query "http://slogan.anub.ru/index.php?slogan=$params"

	set id [::egglib::http_init "::slogan::"]

	if { $slogan(use_proxy) } {
		::egglib::http_set_proxy $id $slogan(proxy_host) $slogan(proxy_port)
	}
	::egglib::http_set_timeout $id $slogan(timeout)
  	::egglib::http_get $id $query [list $nick $uhost $chan]
}

proc ::slogan::on_error {id nick uhost chan} {
	global slogan
  	catch {unset slogan(host,$uhost)}

	::egglib::out $nick $chan "    slogan.anub.ru... -.-"
}

proc ::slogan::on_data { id html nick uhost chan } {
	global slogan; global sp_version
  	catch {unset slogan(host,$uhost)}
  
	set ret ""

	regsub -all -- \n $html {} html
	regsub -all -- <tr> $html \n<tr> html
	regsub -all -- </tr> $html </tr>\n html
	
	if {[info exists sp_version]} {set html [encoding convertfrom cp1251 $html]}
	
	#::egglib::writedata "debug.htm" [list $html]
	
	foreach line [split $html \n] {
			if { [regexp -nocase -- {<div\ align\=\"center\"><b><font\ size\=\"3\"\ face\=\"Arial\">(.*?)<br></font></b></div>} $line garb ret] } {
				set ret [string trim $ret]
				break
			}
	}

	set ret [::egglib::unhtml $ret]

	if { $ret == ""} {
		::egglib::out $nick $chan ",      -.-"
		catch {unset slogan(regquery,$uhost)}
		return
	}

	if { $nick == $chan } {
		::egglib::out $nick $chan "\00312$ret\003"
	} else {
		if { [::slogan::notice $chan] } {
			::egglib::outn $nick "\002$nick\002: \00312$ret\003"
		} else {
			::egglib::out $nick $chan "\00312$ret\003"
		}
	}
}

proc ::slogan::pub_mode { nick mask hand chan text } {

	::egglib::publog $nick $chan "slogmode" "$text"

	set arg [::egglib::tolower [lindex $text 0]] 

	if { [llength $text] == 0 } {
		::egglib::outhc $nick $chan "!slogmode" "<notice|channel|none>"
		set mode [channel get $chan slogan-mode]
			::egglib::outc $nick $chan " :\0035 $mode\003."
			return
	}

	if { ![string match "notice" $arg] &&
		 ![string match "channel" $arg] &&
		 ![string match "none" $arg] } {
		::egglib::outc $nick $chan " .  \0034!slogmode\0035 <notice|channel|none>\003"
		return
	}

	channel set $chan slogan-mode $arg
	savechannels

	::egglib::outc $nick $chan "\0032    : \00312$arg\003."

}

proc ::slogan::active { chan } {
  	set mode [channel get $chan slogan-mode]
  	if { ![string match $mode "none"] } {
  		if { [string match $mode "notice"] || [string match $mode "channel"] } { return 1}
 	}
 	return 0
}

proc ::slogan::notice { chan } {
	set mode [channel get $chan slogan-mode]
	if { [string match $mode "notice"] } { return 1 }
	return 0
}

::egglib::srcloadlog "slogan" $slogan(ver) $slogan(authors)